"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.setPreviewLocale = exports.saveSchema = exports.resetSchema = exports.getProjectSchemaFromLocalStorage = exports.getProjectSchema = exports.getPreviewLocale = exports.getPageSchema = exports.getPackagesFromLocalStorage = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _dialog = _interopRequireDefault(require("@alifd/next/lib/dialog"));
var _message = _interopRequireDefault(require("@alifd/next/lib/message"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _lowcodeEngine = require("@alilc/lowcode-engine");
var _lowcodePluginInject = require("@alilc/lowcode-plugin-inject");
var _lowcodeTypes = require("@alilc/lowcode-types");
var _defaultPageSchema = _interopRequireDefault(require("./defaultPageSchema.json"));
var _defaultI18nSchema = _interopRequireDefault(require("./defaultI18nSchema.json"));
var generateProjectSchema = function generateProjectSchema(pageSchema, i18nSchema) {
  return {
    componentsTree: [pageSchema],
    componentsMap: _lowcodeEngine.material.componentsMap,
    version: '1.0.0',
    i18n: i18nSchema
  };
};
var saveSchema = exports.saveSchema = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(scenarioName) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          setProjectSchemaToLocalStorage(scenarioName);
          _context.next = 4;
          return setPackagesToLocalStorage(scenarioName);
        case 4:
          _message["default"].success('成功保存到本地');
        case 5:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function saveSchema(_x) {
    return _ref.apply(this, arguments);
  };
}();
var resetSchema = exports.resetSchema = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(scenarioName) {
    var _project$simulatorHos;
    var defaultSchema;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          _context2.prev = 1;
          _context2.next = 4;
          return new Promise(function (resolve, reject) {
            _dialog["default"].confirm({
              content: '确定要重置吗？您所有的修改都将消失！',
              onOk: function onOk() {
                resolve();
              },
              onCancel: function onCancel() {
                reject();
              }
            });
          });
        case 4:
          _context2.next = 9;
          break;
        case 6:
          _context2.prev = 6;
          _context2.t0 = _context2["catch"](1);
          return _context2.abrupt("return");
        case 9:
          defaultSchema = generateProjectSchema(_defaultPageSchema["default"], _defaultI18nSchema["default"]);
          _lowcodeEngine.project.importSchema(defaultSchema);
          (_project$simulatorHos = _lowcodeEngine.project.simulatorHost) === null || _project$simulatorHos === void 0 ? void 0 : _project$simulatorHos.rerender();
          setProjectSchemaToLocalStorage(scenarioName);
          _context2.next = 15;
          return setPackagesToLocalStorage(scenarioName);
        case 15:
          _message["default"].success('成功重置页面');
        case 16:
        case "end":
          return _context2.stop();
      }
    }, _callee2, null, [[1, 6]]);
  }));
  return function resetSchema(_x2) {
    return _ref2.apply(this, arguments);
  };
}();
var getLSName = function getLSName(scenarioName, ns) {
  if (ns === void 0) {
    ns = 'projectSchema';
  }
  return scenarioName + ":" + ns;
};
var getProjectSchemaFromLocalStorage = exports.getProjectSchemaFromLocalStorage = function getProjectSchemaFromLocalStorage(scenarioName) {
  if (!scenarioName) {
    console.error('scenarioName is required!');
    return;
  }
  var localValue = window.localStorage.getItem(getLSName(scenarioName));
  if (localValue) {
    return JSON.parse(localValue);
  }
  return undefined;
};
var setProjectSchemaToLocalStorage = function setProjectSchemaToLocalStorage(scenarioName) {
  if (!scenarioName) {
    console.error('scenarioName is required!');
    return;
  }
  window.localStorage.setItem(getLSName(scenarioName), JSON.stringify(_lowcodeEngine.project.exportSchema(_lowcodeTypes.IPublicEnumTransformStage.Save)));
};
var setPackagesToLocalStorage = /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(scenarioName) {
    var packages;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          if (scenarioName) {
            _context3.next = 3;
            break;
          }
          console.error('scenarioName is required!');
          return _context3.abrupt("return");
        case 3:
          _context3.next = 5;
          return (0, _lowcodePluginInject.filterPackages)(_lowcodeEngine.material.getAssets().packages);
        case 5:
          packages = _context3.sent;
          window.localStorage.setItem(getLSName(scenarioName, 'packages'), JSON.stringify(packages));
        case 7:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return function setPackagesToLocalStorage(_x3) {
    return _ref3.apply(this, arguments);
  };
}();
var getPackagesFromLocalStorage = exports.getPackagesFromLocalStorage = function getPackagesFromLocalStorage(scenarioName) {
  if (!scenarioName) {
    console.error('scenarioName is required!');
    return;
  }
  return JSON.parse(window.localStorage.getItem(getLSName(scenarioName, 'packages')) || '{}');
};
var getProjectSchema = exports.getProjectSchema = /*#__PURE__*/function () {
  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(scenarioName) {
    var pageSchema;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          _context4.next = 3;
          return getPageSchema(scenarioName);
        case 3:
          pageSchema = _context4.sent;
          return _context4.abrupt("return", generateProjectSchema(pageSchema, _defaultI18nSchema["default"]));
        case 5:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function getProjectSchema(_x4) {
    return _ref4.apply(this, arguments);
  };
}();
var getPageSchema = exports.getPageSchema = /*#__PURE__*/function () {
  var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(scenarioName) {
    var _getProjectSchemaFrom, _getProjectSchemaFrom2;
    var pageSchema;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          if (scenarioName === void 0) {
            scenarioName = 'unknown';
          }
          pageSchema = (_getProjectSchemaFrom = getProjectSchemaFromLocalStorage(scenarioName)) === null || _getProjectSchemaFrom === void 0 ? void 0 : (_getProjectSchemaFrom2 = _getProjectSchemaFrom.componentsTree) === null || _getProjectSchemaFrom2 === void 0 ? void 0 : _getProjectSchemaFrom2[0];
          if (!pageSchema) {
            _context5.next = 4;
            break;
          }
          return _context5.abrupt("return", pageSchema);
        case 4:
          return _context5.abrupt("return", _defaultPageSchema["default"]);
        case 5:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return function getPageSchema(_x5) {
    return _ref5.apply(this, arguments);
  };
}();
var getPreviewLocale = exports.getPreviewLocale = function getPreviewLocale(scenarioName) {
  var key = getLSName(scenarioName, 'previewLocale');
  return window.localStorage.getItem(key) || 'zh-CN';
};
var setPreviewLocale = exports.setPreviewLocale = function setPreviewLocale(scenarioName, locale) {
  var key = getLSName(scenarioName, 'previewLocale');
  window.localStorage.setItem(key, locale || 'zh-CN');
  window.location.reload();
};